package fileio;
import java.awt.image.BufferedImage;
import java.io.DataInputStream;
import java.io.DataOutputStream;

//--------------------------------------------------------------------//
/**
 * Windowsrbg}bvt@Co̓NX
 */
public class BitmapImageIO extends BinaryDataIO{

/** 𑜓x */
  public static final int PIX_PER_METER=4724;

/** 摜f[^ */
  public BufferedImage image;

/**
 * Windowsrbg}bvt@Co̓IuWFNg\z
 */
  public BitmapImageIO(){
    this(null);
  }

/**
 * Windowsrbg}bvt@Co̓IuWFNg\z
 * @param image 摜f[^
 */
  public BitmapImageIO(BufferedImage image){
    super();
    this.image=image;
  }

//--------------------------------------------------------------------//
/**
 * f[^ǂݍ
 * @param name f[^
 * @param dis ̓Xg[
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  public void readData(String name,DataInputStream dis)
    throws Exception{

// t@Cwb_
    int bfType=dis.readUnsignedShort();
    int bfSize=readInt(dis);
    int bfReserved1=dis.readUnsignedShort();
    int bfReserved2=dis.readUnsignedShort();
    int bfOffBits=readInt(dis);

// wb_
    int biSize=readInt(dis);
    int biWidth=readInt(dis);
    int biHeight=readInt(dis);
    int biPlanes=readShort(dis);
    int biBitCount=readShort(dis);
    int biCompression=readInt(dis);
    int biSizeImage=readInt(dis);
    int biXPixPerMeter=readInt(dis);
    int biYPixPerMeter=readInt(dis);
    int biClrUsed=readInt(dis);
    int biCirImportant=readInt(dis);

// rbg}bvf[^
    image=new BufferedImage
      (biWidth,biHeight,BufferedImage.TYPE_INT_RGB);
    if(biBitCount==24){
      int padding=biWidth%4;
      for(int j=0;j<biHeight;j++){
      	for(int i=0;i<biWidth;i++){
      	  int b=dis.readUnsignedByte();
      	  int g=dis.readUnsignedByte();
      	  int r=dis.readUnsignedByte();
      	  int rgb=(r<<16)|(g<<8)|b;
      	  image.setRGB(i,biHeight-j-1,rgb);
      	}
      	dis.skipBytes(padding);
      }
    }
    else if(biBitCount==32){
      for(int j=0;j<biHeight;j++){
      	for(int i=0;i<biWidth;i++){
      	  int rgb=readInt(dis);
      	  image.setRGB(i,biHeight-j-1,rgb);
      	}
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * f[^
 * @param dos o̓Xg[
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  public void writeData(DataOutputStream dos) throws Exception{
    int width=image.getWidth();
    int height=image.getHeight();
    int size=3*width*height;
    int padding=width%4;

// t@Cwb_
    dos.writeShort(0x424d);
    writeInt(dos,size+54);
    writeShort(dos,0);
    writeShort(dos,0);
    writeInt(dos,54);

// wb_
    writeInt(dos,40);
    writeInt(dos,width);
    writeInt(dos,height);
    writeShort(dos,1);
    writeShort(dos,24);
    writeInt(dos,0);
    writeInt(dos,size);
    writeInt(dos,PIX_PER_METER);
    writeInt(dos,PIX_PER_METER);
    writeInt(dos,0);
    writeInt(dos,0);

// rbg}bvf[^
    for(int j=0;j<height;j++){
      for(int i=0;i<width;i++){
      	int rgb=image.getRGB(i,height-j-1);
      	dos.writeByte(0xff&rgb);
      	dos.writeByte(0xff&(rgb>>8));
      	dos.writeByte(0xff&(rgb>>16));
      }
      for(int i=0;i<padding;i++){
      	dos.writeByte(0);
      }
    }
    dos.close();
  }

//--------------------------------------------------------------------//
/**
 * gGfBA̐f[^ǂݍ
 * @param dis ̓Xg[
 * @return ǂݍ int ^f[^
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected static int readInt(DataInputStream dis) throws Exception{
    return Integer.reverseBytes(dis.readInt());
  }

//--------------------------------------------------------------------//
/**
 * gGfBA2oCgf[^ǂݍ
 * @param dis ̓Xg[
 * @return ǂݍ int ^f[^
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected static int readShort(DataInputStream dis) throws Exception{
    return (Integer.reverseBytes(dis.readUnsignedShort())>>16);
  }

//--------------------------------------------------------------------//
/**
 * f[^gGfBAŏ
 * @param dos o̓Xg[
 * @param value ސ
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected static void writeInt(DataOutputStream dos,int value)
    throws Exception{

    dos.writeInt(Integer.reverseBytes(value));
  }

//--------------------------------------------------------------------//
/**
 * 2oCgf[^gGfBAŏ
 * @param dos o̓Xg[
 * @param value ސ
 * @throws Exception 炩̗RŃt@Cǂ߂ȂƂ
 */
  protected static void writeShort(DataOutputStream dos,int value)
    throws Exception{

    dos.writeShort((short)(Integer.reverseBytes(value)>>16));
  }
}
