package fileio;
import java.io.IOException;
import java.util.Date;
import java.util.logging.FileHandler;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.logging.LogRecord;
import java.util.logging.Formatter;
import data.Clock;

//--------------------------------------------------------------------//
/**
 * bZ[W\NX
 */
public class MessageBoard{

/** O쐬IuWFNg */
  private static final String LOG_NAME="JavaLogger";

/** Ȍ */
  private static final Formatter FORMATTER=new MessageFormatter();

/** bZ[W\IuWFNg */
  private static final MessageBoard BOARD=new MessageBoard();

/** bZ[W̍s */
  private int count;

/** O쐬IuWFNg */
  private Logger logger;

/** ݂̃t@Cnh[ */
  private FileHandler current;

/**
 * bZ[W\IuWFNg\z
 */
  protected MessageBoard(){
    count=0;
    logger=Logger.getLogger(LOG_NAME);
    logger.setLevel(Level.INFO);
    current=null;
    setFormatter();
  }

//--------------------------------------------------------------------//
/**
 * Ot@Cǉ
 * @param fileName Ot@C
 */
  public static void addLogFile(String fileName){
    BOARD.addLogFileName(fileName);
  }

//--------------------------------------------------------------------//
/**
 * Ot@Cǉ
 * @param fileName Ot@C
 */
  private void addLogFileName(String fileName){
    try{
      if(current!=null){
      	current.close();
      	logger.removeHandler(current);
      }
      current=new FileHandler(fileName);
      logger.addHandler(current);
    }
    catch(IOException ex){
      ex.printStackTrace();
    }
    setFormatter();
  }

//--------------------------------------------------------------------//
/**
 * Ot@Cǉ
 */
  private void setFormatter(){
    Logger parent=logger;
    while(parent!=null){
      Handler handlers[]=parent.getHandlers();
      for(int i=0;i<handlers.length;i++){
      	handlers[i].setFormatter(FORMATTER);
      }
      parent=parent.getParent();
    }
  }

//--------------------------------------------------------------------//
/**
 * xbZ[W\
 * @param message bZ[W
 */
  public static void warning(String message){
    BOARD.printWarning(message);
  }

//--------------------------------------------------------------------//
/**
 * xbZ[W\
 * @param e O
 */
  public static void warning(Throwable e){
    BOARD.printWarning(String.valueOf(e));
    StackTraceElement trace[]=e.getStackTrace();
    for(int i=0;i<trace.length;i++){
      BOARD.printWarning("\tat "+trace[i]);
    }
    Throwable cause=e.getCause();
    if(cause!=null) warning(cause);
  }

//--------------------------------------------------------------------//
/**
 * s
 */
  public static void print(){
    BOARD.printInfo("");
  }

//--------------------------------------------------------------------//
/**
 * bZ[W\
 * @param message bZ[W
 */
  public static void print(String message){
    BOARD.printInfo(message);
  }

//--------------------------------------------------------------------//
/**
 * ݎ\
 */
  public static void printDate(){
    BOARD.printInfo(Clock.dateString());
  }

//--------------------------------------------------------------------//
/**
 * \
 * @param date \ <code>Date</code>
 */
  public static void print(Date date){
    BOARD.printInfo(Clock.dateString(date));
  }

//--------------------------------------------------------------------//
/**
 * O\
 * @param ex \O
 */
  public static void print(Exception ex){
    BOARD.printInfo(String.valueOf(ex));
  }

//--------------------------------------------------------------------//
/**
 * xbZ[W\
 * @param message bZ[W
 */
  private void printWarning(String message){
    count++;
    logger.log(Level.WARNING,message);
  }

//--------------------------------------------------------------------//
/**
 * bZ[W\
 * @param message bZ[W
 */
  private void printInfo(String message){
    count++;
    logger.log(Level.INFO,message);
  }

//--------------------------------------------------------------------//
/**
 * ȌNX
 */
  private static class MessageFormatter extends Formatter{

    private static final String LINE_SEPARATOR="\r\n"; // Windows
//    private static final String LINE_SEPARATOR="\n"; // Unix,Linux

    public MessageFormatter(){
      super();
    }

//--------------------------------------------------------------------//
/**
 * OR[h̃tH[}bgꂽԂ
 * @param record OR[h
 * @return OR[h\
 */
    public String format(LogRecord record){
      return record.getMessage()+LINE_SEPARATOR;
    }
  }
}
