package gui;
import java.awt.Point;
import java.awt.event.MouseEvent;
import javax.swing.DefaultListModel;
import javax.swing.JList;
import javax.swing.ListSelectionModel;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;
import javax.swing.event.MouseInputListener;

//--------------------------------------------------------------------//
/**
 * ҏW\ȃXg
 */
public class EditableList extends JList<Object>
  implements ListSelectionListener,MouseInputListener{

/** }EXʒu */
  protected Point mouse;

/** IĂ鍀ڂ̃CfbNX */
  protected int selectedIndex;

/** ҏW\ǂ\p[^ */
  protected boolean editable;

/**
 * ҏW\ȃXg\z
 */
  public EditableList(){
    super(new DefaultListModel<Object>());
    mouse=new Point();
    selectedIndex=-1;
    setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
    addListSelectionListener(this);
    addMouseListener(this);
    addMouseMotionListener(this);
    editable=true;
  }

//--------------------------------------------------------------------//
/**
 * IڂύX
 * @param e ANVƂCxg
 */
  public void valueChanged(ListSelectionEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EX{^̏s
 * @param e }EXANVƂCxg
 */
  public void mousePressed(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    selectedIndex=locationToIndex(mouse);
  }

//--------------------------------------------------------------------//
/**
 * }EX{^𗣂̏s
 * @param e }EXANVƂCxg
 */
  public void mouseReleased(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    int index=locationToIndex(mouse);
    moveElement(selectedIndex,index);
    selectedIndex=-1;
  }

//--------------------------------------------------------------------//
/**
 * }EXNbN̏s
 * @param e }EXANVƂCxg
 */
  public void mouseClicked(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXplɓ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseEntered(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXplȍs
 * @param e }EXANVƂCxg
 */
  public void mouseExited(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXړ̏s
 * @param e }EXANVƂCxg
 */
  public void mouseMoved(MouseEvent e){
  }

//--------------------------------------------------------------------//
/**
 * }EXhbȌs
 * @param e }EXANVƂCxg
 */
  public void mouseDragged(MouseEvent e){
    mouse.setLocation(e.getX(),e.getY());
    int index=locationToIndex(mouse);
    moveElement(selectedIndex,index);
    selectedIndex=index;
  }

//--------------------------------------------------------------------//
/**
 * ҏW\ǂύX
 * @param editable ҏW\ȏꍇ true
 */
  public void setEditable(boolean editable){
    this.editable=editable;
  }

//--------------------------------------------------------------------//
/**
 * Xgێ <code>DefaultListModel</code> Ԃ
 * @return Xgێ <code>DefaultListModel</code>
 */
  public DefaultListModel<Object> getDefaultListModel(){
    return (DefaultListModel<Object>)getModel();
  }

//--------------------------------------------------------------------//
/**
 * Xg̍Ōɗvfǉ
 * @param element ǉvf
 */
  public void addElement(Object element){
    getDefaultListModel().addElement(element);
  }

//--------------------------------------------------------------------//
/**
 * w肳ꂽʒuɗvfǉ
 * @param index vfǉCfbNX
 * @param element ǉvf
 */
  public void addElement(int index,Object element){
    getDefaultListModel().add(index,element);
  }

//--------------------------------------------------------------------//
/**
 * Xg̍Ōɗvfǉ<br>
 * XgڂƏdĂꍇ, vf null ̏ꍇ͒ǉȂ
 * @param element ǉvf
 */
  public void addNewElement(Object element){
    if(!editable || (element==null)) return;
    DefaultListModel<Object> listModel=getDefaultListModel();
    int size=listModel.getSize();
    for(int i=0;i<size;i++){
      if(element.equals(listModel.get(i))) return;
    }
    listModel.addElement(element);
  }

//--------------------------------------------------------------------//
/**
 * w肳ꂽʒuɗvfǉ<br>
 * XgڂƏdĂꍇ, vf null ̏ꍇ͒ǉȂ
 * @param index vfǉCfbNX
 * @param element ǉvf
 */
  public void addNewElement(int index,Object element){
    if(!editable || (element==null)) return;
    DefaultListModel<Object> listModel=getDefaultListModel();
    int size=listModel.getSize();
    for(int i=0;i<size;i++){
      if(element.equals(listModel.get(i))) return;
    }
    listModel.add(index,element);
  }

//--------------------------------------------------------------------//
/**
 * vf폜
 * @param element 폜vf
 * @return Xg̗vfłꍇ true
 */
  public boolean removeElement(Object element){
    if(!editable) return false;
    return getDefaultListModel().removeElement(element);
  }

//--------------------------------------------------------------------//
/**
 * w肳ꂽʒu̗vf폜
 * @param index vf폜CfbNX
 * @return 폜ꂽvf
 */
  public Object removeElement(int index){
    if(!editable) return null;
    return getDefaultListModel().remove(index);
  }

//--------------------------------------------------------------------//
/**
 * ݑIĂvf폜
 * @return 폜ꂽvf
 */
  public Object removeSelected(){
    if(!editable) return null;
    Object removed=getSelectedValue();
    getDefaultListModel().removeElement(removed);
    return removed;
  }

//--------------------------------------------------------------------//
/**
 * vfړ
 * @param beforeIndex vf̈ړÕCfbNX
 * @param afterIndex ړ̃CfbNX
 * @return ړvf
 */
  protected Object moveElement(int beforeIndex,int afterIndex){
    if(editable && (beforeIndex>=0) && (afterIndex>=0)
    && (beforeIndex!=afterIndex)){
      DefaultListModel<Object> listModel=getDefaultListModel();
      Object moved=listModel.remove(beforeIndex);
      listModel.add(afterIndex,moved);
      return moved;
    }
    return null;
  }

//--------------------------------------------------------------------//
/**
 * vfS폜
 */
  public void clear(){
    getDefaultListModel().clear();
  }
}
