package iso;

//--------------------------------------------------------------------//
/**
 * }[`OL[u@
 */
public class MarchingCubes{

/** {̐}` */
  private static final BaseCube BASES[]=
    {new BaseCube(new boolean[]{true,true,true,true,
      	      	      	      	true,true,true,true},
      	      	  new int[]{-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{true,true,true,false,
      	      	      	      	false,true,true,true},
      	      	  new int[]{2,11,3,7,4,8,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{false,true,false,true,
      	      	      	      	false,true,true,true},
      	      	  new int[]{1,10,2,7,4,3,4,0,3,-1,-1,-1}),
     new BaseCube(new boolean[]{false,true,true,true,
      	      	      	      	false,false,true,false},
      	      	  new int[]{11,6,3,6,5,3,5,0,3,5,9,0}),
     new BaseCube(new boolean[]{true,true,false,false,
      	      	      	      	false,true,false,true},
      	      	  new int[]{1,5,3,11,3,6,3,5,6,7,4,8}),
     new BaseCube(new boolean[]{true,true,true,true,
      	      	      	      	false,true,true,true},
      	      	  new int[]{7,4,8,-1,-1,-1,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{true,true,false,true,
      	      	      	      	false,true,true,true},
      	      	  new int[]{7,4,8,1,10,2,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{true,false,true,false,
      	      	      	      	false,true,true,true},
      	      	  new int[]{7,4,8,9,1,0,2,11,3,-1,-1,-1}),
     new BaseCube(new boolean[]{true,false,false,true,
      	      	      	      	false,true,true,false},
      	      	  new int[]{9,2,0,9,10,2,4,8,11,4,11,6}),
     new BaseCube(new boolean[]{true,false,true,false,
      	      	      	      	false,true,false,true},
      	      	  new int[]{9,1,0,2,11,3,5,6,10,4,8,7}),
     new BaseCube(new boolean[]{false,true,true,true,
      	      	      	      	false,true,true,true},
      	      	  new int[]{4,0,3,4,3,7,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{false,true,true,true,
      	      	      	      	false,true,true,false},
      	      	  new int[]{4,0,6,6,0,3,6,3,11,-1,-1,-1}),
     new BaseCube(new boolean[]{false,false,true,true,
      	      	      	      	false,false,true,true},
      	      	  new int[]{5,1,3,7,5,3,-1,-1,-1,-1,-1,-1}),
     new BaseCube(new boolean[]{false,true,false,false
      	      	      	      	,false,true,true,true},
      	      	  new int[]{4,0,7,7,0,1,7,1,11,10,11,1}),
     new BaseCube(new boolean[]{true,true,false,false,
      	      	      	      	false,true,true,false},
      	      	  new int[]{4,8,6,6,8,3,6,3,10,10,3,1})};

/** t@Zbg */
  public static final int FACET[][]=createFacetData();

//--------------------------------------------------------------------//
/**
 * ̐}`̃CfbNXԂ
 * @param v _ 0/1
 * @return Y闧̐}`̃CfbNX
 */
  public static int cubeIndex(boolean v[]){
    int index=0;
    if(v[0]) index+=1;
    if(v[1]) index+=2;
    if(v[2]) index+=4;
    if(v[3]) index+=8;
    if(v[4]) index+=16;
    if(v[5]) index+=32;
    if(v[6]) index+=64;
    if(v[7]) index+=128;
    return index;
  }

//--------------------------------------------------------------------//
/**
 * t@Zbgf[^쐬
 * @return t@Zbg̒_ӂ̃|C^
 */
  private static int[][] createFacetData(){
    int vp[][]=allVertexPermutation();
    int ep[][]=allEdgePermutation();
    int facet[][]=new int[256][];
    for(int i=0;i<15;i++){
      BaseCube bc=BASES[i];
      for(int j=0;j<24;j++){
      	int index=cubeIndex(permutateVertex(bc.v,vp[j]));
      	facet[index]=permutateFacet(bc.facet,ep[j]);
      	facet[255-index]=invF(facet[index]);
      }
    }
    return facet;
  }

//--------------------------------------------------------------------//
/**
 * ̐}`̑S_up^[Ԃ
 * @return Sup^[i[z
 */
  private static int[][] allVertexPermutation(){
    int ii=0;
    int v[]={0,1,2,3,4,5,6,7};
    int vp[][]=new int[24][8];

    for(int j=0;j<4;j++){
      for(int i=0;i<4;i++){
      	vp[ii]=v;
      	ii++;
      	v=rotateVertexX(v);
      }
      v=rotateVertexZ(v);
    }
    v=rotateVertexY(v);
    for(int i=0;i<4;i++){
      vp[ii]=v;
      ii++;
      v=rotateVertexX(v);
    }
    v=rotateVertexY(v);
    v=rotateVertexY(v);
    for(int i=0;i<4;i++){
      vp[ii]=v;
      ii++;
      v=rotateVertexX(v);
    }
    return vp;
  }

//--------------------------------------------------------------------//
/**
 * ̐}`̑SӒup^[Ԃ
 * @return Sup^[i[z
 */
  private static int[][] allEdgePermutation(){
    int ii=0;
    int e[]={0,1,2,3,4,5,6,7,8,9,10,11};
    int ep[][]=new int[24][12];

    for(int j=0;j<4;j++){
      for(int i=0;i<4;i++){
      	ep[ii]=e;
      	ii++;
      	e=rotateEdgeX(e);
      }
      e=rotateEdgeZ(e);
    }
    e=rotateEdgeY(e);
    for(int i=0;i<4;i++){
      ep[ii]=e;
      ii++;
      e=rotateEdgeX(e);
    }
    e=rotateEdgeY(e);
    e=rotateEdgeY(e);
    for(int i=0;i<4;i++){
      ep[ii]=e;
      ii++;
      e=rotateEdgeX(e);
    }
    return ep;
  }

//--------------------------------------------------------------------//
/**
 * _ <i>x</i> ɉ]
 * @param v _|C^
 * @return ]_|C^
 */
  private static int[] rotateVertexX(int v[]){
    return new int[]{v[3],v[2],v[6],v[7],v[0],v[1],v[5],v[4]};
  }

//--------------------------------------------------------------------//
/**
 * ӂ <i>x</i> ɉ]
 * @param e Ӄ|C^
 * @return ]Ӄ|C^
 */
  private static int[] rotateEdgeX(int e[]){
    return new int[]{e[2],e[10],e[6],e[11],e[0],e[9],e[4],e[8],
      	      	     e[3],e[1],e[5],e[7]};
  }

//--------------------------------------------------------------------//
/**
 * _ <i>y</i> ɉ]
 * @param v _|C^
 * @return ]_|C^
 */
  private static int[] rotateVertexY(int v[]){
    return new int[]{v[4],v[0],v[3],v[7],v[5],v[1],v[2],v[6]};
  }

//--------------------------------------------------------------------//
/**
 * ӂ <i>y</i> ɉ]
 * @param e Ӄ|C^
 * @return ]Ӄ|C^
 */
  private static int[] rotateEdgeY(int e[]){
    return new int[]{e[8],e[3],e[11],e[7],e[9],e[1],e[10],e[5],
      	      	     e[4],e[0],e[2],e[6]};
  }

//--------------------------------------------------------------------//
/**
 * _ <i>z</i> ɉ]
 * @param v _|C^
 * @return ]_|C^
 */
  private static int[] rotateVertexZ(int v[]){
    return new int[]{v[3],v[0],v[1],v[2],v[7],v[4],v[5],v[6]};
  }

//--------------------------------------------------------------------//
/**
 * ӂ <i>z</i> ɉ]
 * @param e Ӄ|C^
 * @return ]Ӄ|C^
 */
  private static int[] rotateEdgeZ(int e[]){
    return new int[]{e[3],e[0],e[1],e[2],e[7],e[4],e[5],e[6],
      	      	     e[11],e[8],e[9],e[10]};
  }

//--------------------------------------------------------------------//
/**
 * t@Zbǧ𔽓]
 * @param v _ 0/1
 * @return ]t@Zbgf[^
 */
  private static int[] invF(int f[]){
    return new int[]{f[2],f[1],f[0],f[5],f[4],f[3],
      	      	     f[8],f[7],f[6],f[11],f[10],f[9]};
  }

//--------------------------------------------------------------------//
/**
 * _ 0/1 u
 * @param v _ 0/1
 * @param perm u|C^
 * @return u_f[^
 */
  private static boolean[] permutateVertex(boolean v[],int perm[]){
    boolean p[]=new boolean[8];
    for(int i=0;i<8;i++) p[i]=v[perm[i]];
    return p;
  }

//--------------------------------------------------------------------//
/**
 * t@Zbgu
 * @param facet t@Zbg̒_ӂ̃|C^
 * @param perm u|C^
 * @return ut@Zbgf[^
 */
  private static int[] permutateFacet(int facet[],int perm[]){
    int f[]=new int[12];
    int ip[]=new int[12];
    for(int i=0;i<12;i++) ip[perm[i]]=i;
    for(int i=0;i<12;i++){
      if(facet[i]<0) f[i]=-1;
      else    	     f[i]=ip[facet[i]];
    }
    return f;
  }

//--------------------------------------------------------------------//
/**
 * }[`OL[u@̊{̐}`
 */
  private static class BaseCube{

/** _ 0/1 */
    boolean v[];

/** t@Zbg̒_ӂ̃|C^ */
    int facet[];

/**
 * }[`OL[u@̊{̐}`\z
 * @param v _ 0/1
 * @param facet t@Zbg̒_ӂ̃|C^
 */
    public BaseCube(boolean v[],int facet[]){
      this.v=v;
      this.facet=facet;
    }
  }
}