package iso.component;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import gui.AcceleratorMenu;
import gui.ExitAction;
import gui.HelpAction;
import gui.VersionInfoAction;
import iso.io.ChannelFlowLoadAction;
import iso.io.ChannelFlowSaveAction;
import laf.CommandMap;
import laf.WordMap;
import resourcemanager.IconManager;

//--------------------------------------------------------------------//
/**
 * j[o[
 */
public class ChannelFlowMenuBar extends JMenuBar{

/**
 * j[o[\z
 * @param frame \t[
 */
  public ChannelFlowMenuBar(ChannelFlowViewFrame frame){
    super();
    add(fileMenu(frame));
    add(setMenu(frame));
    add(helpMenu(frame));
  }

//--------------------------------------------------------------------//
/**
 * File j[쐬
 * @param frame \t[
 * @return File j[
 */
  private JMenu fileMenu(ChannelFlowViewFrame frame){
    AcceleratorMenu fileMenu=
      new AcceleratorMenu(CommandMap.get(CommandMap.FILE));

    fileMenu.add(new NewDataAction(frame),"ctrl N");
    fileMenu.add(new ChannelFlowLoadAction(frame),"ctrl O");
    fileMenu.add(new ChannelFlowSaveAction(frame),"ctrl S");
    fileMenu.addSeparator();
    fileMenu.add(new SequenceAction(frame));
    fileMenu.addSeparator();
    fileMenu.add(new ExitAction(frame),"ctrl X");

    return fileMenu;
  }

//--------------------------------------------------------------------//
/**
 * Setting j[쐬
 * @param frame \t[
 * @return Setting j[
 */
  private JMenu setMenu(ChannelFlowViewFrame frame){
    AcceleratorMenu setMenu=
      new AcceleratorMenu(CommandMap.get(CommandMap.SET));

    setMenu.add(new EditIsoSurfaceAction(frame));
    setMenu.addSeparator();
    setMenu.add(new SetTransformAction(frame));

    return setMenu;
  }

//--------------------------------------------------------------------//
/**
 * Help j[쐬
 * @param frame \t[
 * @return Help j[
 */
  private JMenu helpMenu(ChannelFlowViewFrame frame){
    AcceleratorMenu helpMenu=
      new AcceleratorMenu(CommandMap.get(CommandMap.HELP));

    helpMenu.add(new HelpAction(frame,"index.html"),"ctrl H");
    helpMenu.add(new VersionInfoAction
      (frame,new String[]{WordMap.get(WordMap.VERSION1),
      	      	      	  WordMap.get(WordMap.VERSION2),
      	      	      	  WordMap.get(WordMap.VERSION3),
      	      	      	  WordMap.get(WordMap.VERSION4)},
       IconManager.get(ChannelFlowViewFrame.ICON_NAME)),"ctrl V");

    return helpMenu;
  }
}
