package iso.component;
import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.JFrame;
import gui.ExitAction;
import iso.ChannelFlowModel;
import iso.ChannelFlowViewModel;
import laf.WordMap;
import resourcemanager.IconManager;

//--------------------------------------------------------------------//
/**
 * `l\t[
 */
public class ChannelFlowViewFrame extends JFrame{

/** ftHg`ʃTCY */
//  public static final Dimension DEFAULT_SIZE=new Dimension(650,416);
  public static final Dimension DEFAULT_SIZE=new Dimension(1290,776);

/** ACR摜t@C */
  public static final String ICON_NAME="ChannelViewIcon.png";

/** `l\pl */
  protected ChannelFlowViewPanel panel;

/** `lf[^f */
  protected ChannelFlowModel model;

/** lʃXg */
  protected IsoSurfaceList list;

/**
 * `l\t[\z
 */
  public ChannelFlowViewFrame(){
    super(WordMap.get(WordMap.TITLE));
    list=new IsoSurfaceList();
    model=new ChannelFlowModel(list);
    panel=new ChannelFlowViewPanel(model,list);

    setJMenuBar(new ChannelFlowMenuBar(this));
    getContentPane().setLayout(new BorderLayout());
    getContentPane().add(panel,BorderLayout.CENTER);
    ChannelFlowActionManager manager=new ChannelFlowActionManager(panel);

    setBounds(0,0,DEFAULT_SIZE.width,DEFAULT_SIZE.height);
    setIconImage(IconManager.getImage(ICON_NAME));
    setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
    addWindowListener(new ExitAction.WinExitEventHandler(this));
  }

//--------------------------------------------------------------------//
/**
 * `l\plԂ
 * @return `l\pl
 */
  public ChannelFlowViewPanel getPanel(){
    return panel;
  }

//--------------------------------------------------------------------//
/**
 * lʃXgԂ
 * @return lʃXg
 */
  public IsoSurfaceList getList(){
    return list;
  }

//--------------------------------------------------------------------//
/**
 * `lf[^fԂ
 * @return `lf[^f
 */
  public ChannelFlowModel getModel(){
    return model;
  }

//--------------------------------------------------------------------//
/**
 * `l\fԂ
 * @return `l\f
 */
  public ChannelFlowViewModel getViewModel(){
    return panel.getViewModel();
  }
}
