package iso.component;
import java.awt.Graphics2D;
import java.awt.Image;
import java.awt.Point;
import java.awt.image.MemoryImageSource;
import figure.Transform;
import gui.BasicViewPanel;
import iso.ChannelFlowModel;
import iso.ChannelFlowViewModel;

//--------------------------------------------------------------------//
/**
 * `l\pl
 */
public class ChannelFlowViewPanel extends BasicViewPanel{

/** `l\f */
  protected ChannelFlowViewModel viewModel;

/** ϊs */
  protected Transform transform;

/** fsړW */
  protected double transCoef;

/** f]xW */
  protected double rotateCoef;

/** fgEkW */
  protected double zoomCoef;

/**
 * `l\pl\z
 * @param model `lf[^f
 * @param list lʃXg
 */
  public ChannelFlowViewPanel(ChannelFlowModel model,
      	      	      	      IsoSurfaceList list){
    transform=new Transform();
    viewModel=new ChannelFlowViewModel(model,list,transform);
  }

//--------------------------------------------------------------------//
/**
 * `l\fԂ
 * @return `l\f
 */
  public ChannelFlowViewModel getViewModel(){
    return viewModel;
  }

//--------------------------------------------------------------------//
/**
 * WʍWɕϊ
 */
  public void resetCoordinates(){
    viewModel.resetCoordinates();
  }

//--------------------------------------------------------------------//
/**
 * f𕽍sړ
 * @param dx ʏ <i>x</i> ړ
 * @param dy ʏ <i>y</i> ړ
 */
  public void translate(int dx,int dy){
    transform.translate(transCoef*(double)dx,-transCoef*(double)dy,0.0);
  }

//--------------------------------------------------------------------//
/**
 * f]
 * @param dx ʏ <i>x</i> ړ
 * @param dy ʏ <i>y</i> ړ
 */
  public void rotate(int dx,int dy){
    transform.rotate(rotateCoef*(double)dy,rotateCoef*(double)dx,0.0);
  }

//--------------------------------------------------------------------//
/**
 * fgEk
 * @param dx ʏ <i>x</i> ړ
 * @param dy ʏ <i>y</i> ړ
 */
  public void zoom(int dx,int dy){
    transform.zoom(Math.pow(2.0,zoomCoef*(double)(dx+dy)));
  }

//--------------------------------------------------------------------//
/**
 * `ʒu
 */
  public void initView(){
    transform.init();
    update();
  }

//--------------------------------------------------------------------//
/**
 * xɂ
 */
  public void viewX(){
    transform.init();
    transform.rotate(0.0,1.0,0.0,-0.5*Math.PI);
    update();
  }

//--------------------------------------------------------------------//
/**
 * yɂ
 */
  public void viewY(){
    transform.init();
    transform.rotate(1.0,0.0,0.0,0.5*Math.PI);
    update();
  }

//--------------------------------------------------------------------//
/**
 * ʐݒ
 */
  protected void setPaint(){
    super.setPaint();
    viewModel.setView(new Point(panelSize.width/2,panelSize.height/2),
      	      	      panelSize.width,panelSize.height);
    double viewSize=(double)Math.min(panelSize.width,panelSize.height);
    transCoef=1.0;
    rotateCoef=Math.PI/viewSize;
    zoomCoef=1.0/viewSize;
  }

//--------------------------------------------------------------------//
/**
 * `悷
 * @param g `悷OtBbNXReLXg
 */
  protected void paintModel(Graphics2D g){
    int pixel[]=viewModel.getPixel();
    Image renderImage=createImage(new MemoryImageSource
      (panelSize.width,panelSize.height,pixel,0,panelSize.width));
    g.drawImage(renderImage,0,0,this);
  }
}
