package iso.component;
import java.awt.Color;
import java.awt.Component;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JButton;
import javax.swing.JColorChooser;
import javax.swing.JComboBox;
import javax.swing.JOptionPane;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import gui.ColorIcon;
import iso.Attribute;
import laf.CommandMap;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * lʐݒ_CAO
 */
public class IsoSurfaceDialog{

/** _CAO{^ */
  protected static final String
    BUTTONS[]={CommandMap.get(CommandMap.SET),
      	       CommandMap.get(CommandMap.CANCEL)};

/** f[^ޑIR{{bNX */
  protected JComboBox typeBox;

/** 臒l̓tB[h */
  protected JTextField thresField;

/** lʕ\Fݒ{^ */
  protected JButton colorButton;

/** _CAȌL */
  protected Component base;

/** lʕ\F */
  protected Color color;

/**
 * lʐݒ_CAO\z
 * @param base _CAȌL
 * @param attr lʂ̑̏l
 */
  public IsoSurfaceDialog(Component base,Attribute attr){
    typeBox=new JComboBox<String>(Attribute.TYPE);
    if(attr==null){
      typeBox.setSelectedIndex(Attribute.P);
      thresField=new JTextField("-2.5",20);
      color=Color.CYAN;
    }
    else{
      typeBox.setSelectedIndex(attr.type);
      thresField=new JTextField(String.valueOf(attr.thres),20);
      color=attr.color;
    }
    colorButton=new JButton(new ColorSetAction(base,this));
    typeBox.setBorder(new TitledBorder(WordMap.get(WordMap.TYPE)));
    thresField.setBorder
      (new TitledBorder(WordMap.get(WordMap.THRESHOLD)));
  }

//--------------------------------------------------------------------//
/**
 * ̓_CAO\
 * @param base _CAȌL
 * @param attr lʂ̑̏l
 * @return 쐬ꂽlʂ̑
 */
  public static Attribute showDialog(Component base,Attribute attr){
    IsoSurfaceDialog dialog=new IsoSurfaceDialog(base,attr);
    if(dialog.showInputDialog()==0){
      return dialog.getAttribute();
    }
    else{
      return null;
    }
  }

//--------------------------------------------------------------------//
/**
 * \Fݒ肷
 * @param color }bv̈\F
 */
  public void setColor(Color color){
    this.color=color;
  }

//--------------------------------------------------------------------//
/**
 * \FԂ
 * @return }bv̈\F
 */
  public Color getColor(){
    return color;
  }

//--------------------------------------------------------------------//
/**
 * ̓_CAO\
 * @return [UIIvV\l
 */
  public int showInputDialog(){
    return JOptionPane.showOptionDialog
      	     (base,new Object[]{typeBox,thresField,colorButton},
      	      WordMap.get(WordMap.ISOSURFACE),
      	      JOptionPane.DEFAULT_OPTION,JOptionPane.PLAIN_MESSAGE,
      	      null,BUTTONS,BUTTONS[0]);
  }

//--------------------------------------------------------------------//
/**
 * 쐬ꂽlʂ̑o
 * @return 쐬ꂽlʂ̑
 */
  public Attribute getAttribute(){
    int type=typeBox.getSelectedIndex();
    double thres=Double.parseDouble(thresField.getText());
    return new Attribute(type,thres,color);
  }

//--------------------------------------------------------------------//
/**
 * FݒANV
 */
  public static class ColorSetAction extends AbstractAction{

/** _CAȌL */
    private Component base;

/** lʐݒ_CAO */
    private IsoSurfaceDialog dialog;

/** \FACR */
    private ColorIcon icon;

/**
 * ANVIuWFNg\z
 * @param base _CAȌL
 * @param dialog lʐݒ_CAO
 */
    public ColorSetAction(Component base,IsoSurfaceDialog dialog){
      putValue(NAME,actionName());
      icon=new ColorIcon(dialog.getColor(),base);
      putValue(SMALL_ICON,icon);
      this.base=base;
      this.dialog=dialog;
    }

/**
 * ACRw肵ăANVIuWFNg\z
 * @param base _CAȌL
 * @param dialog lʐݒ_CAO
 * @param actionIcon ACR
 */
    public ColorSetAction(Component base,IsoSurfaceDialog dialog,
      	      	      	  Icon actionIcon){
      putValue(SMALL_ICON,actionIcon);
      putValue(SHORT_DESCRIPTION,actionName());
      icon=new ColorIcon(dialog.getColor(),base);
      this.base=base;
      this.dialog=dialog;
    }

//--------------------------------------------------------------------//
/**
 * Fݒ肷
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      Color color=JColorChooser.showDialog
      	(base,WordMap.get(WordMap.COLOR),dialog.getColor());
      if(color!=null){
      	dialog.setColor(color);
      	icon.setColor(color);
      }
    }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
    public static String actionName(){
      return WordMap.get(WordMap.COLOR);
    }
  }
}
