package iso.component;
import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import javax.swing.AbstractAction;
import javax.swing.JButton;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import iso.Attribute;
import iso.IsoSurface;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * lʃXgpl
 */
public class IsoSurfaceListPanel extends JPanel{

/** \t[ */
  private ChannelFlowViewFrame frame;

/**
 * lʃXgpl\z
 * @param frame \t[
 */
  public IsoSurfaceListPanel(ChannelFlowViewFrame frame){
    super();
    this.frame=frame;

    setLayout(new BorderLayout());
    JPanel buttonPanel=new JPanel();
    buttonPanel.setLayout(new GridLayout(1,3));

    add(new JScrollPane(frame.getList()),BorderLayout.CENTER);

    buttonPanel.add(new JButton(new AddSurfaceAction()));
    buttonPanel.add(new JButton(new ReplaceSurfaceAction()));
    buttonPanel.add(new JButton(new DeleteSurfaceAction()));
    add(buttonPanel,BorderLayout.SOUTH);
  }

//--------------------------------------------------------------------//
/**
 * lʒǉANV
 */
  public class AddSurfaceAction extends AbstractAction{

/**
 * ANV\z
 */
    public AddSurfaceAction(){
      putValue(NAME,WordMap.get(WordMap.ADD));
    }

//--------------------------------------------------------------------//
/**
 * lʂǉ
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      IsoSurface s=frame.getList().getSelectedIsoSurface();
      Attribute attr=null;
      if(s!=null) attr=s.attr;
      attr=IsoSurfaceDialog.showDialog(frame,attr);
      if(attr!=null){
      	frame.getViewModel().addIsoSurface(attr);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * lʒuANV
 */
  public class ReplaceSurfaceAction extends AbstractAction{

/**
 * ANV\z
 */
    public ReplaceSurfaceAction(){
      putValue(NAME,WordMap.get(WordMap.REPLACE));
    }

//--------------------------------------------------------------------//
/**
 * lʂu
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      IsoSurface s=frame.getList().getSelectedIsoSurface();
      if(s==null) return;
      Attribute attr=IsoSurfaceDialog.showDialog(frame,s.attr);
      if(attr!=null){
      	frame.getViewModel().setIsoSurface(attr);
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * lʍ폜ANV
 */
  public class DeleteSurfaceAction extends AbstractAction{

/**
 * ANV\z
 */
    public DeleteSurfaceAction(){
      putValue(NAME,WordMap.get(WordMap.REMOVE));
    }

//--------------------------------------------------------------------//
/**
 * lʂ폜
 * @param e ANVƂCxg
 */
    public void actionPerformed(ActionEvent e){
      IsoSurfaceList list=frame.getList();
      if(list.getSelectedIndex()>=0){
      	list.removeSelected();
      }
    }
  }
}
