package iso.component;
import java.awt.event.ActionEvent;
import java.io.File;
import javax.imageio.ImageIO;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import fileio.BitmapImageIO;
import gui.EditableList;
import iso.io.ChannelFlowIO;
import laf.CommandMap;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * V[PXANV
 */
public class SequenceAction extends AbstractAction{

/** _CAO{^ */
  protected static final String
    BUTTONS[]={WordMap.get(WordMap.DO_SEQUENCE),
      	       CommandMap.get(CommandMap.CANCEL)};

/** \t[ */
  private ChannelFlowViewFrame frame;

/**
 * ANV\z
 * @param frame \t[
 */
  public SequenceAction(ChannelFlowViewFrame frame){
    putValue(NAME,actionName());
    this.frame=frame;
  }

/**
 * ACRw肵ăANV\z
 * @param frame \t[
 * @param icon ACR
 */
  public SequenceAction(ChannelFlowViewFrame frame,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.frame=frame;
  }

//--------------------------------------------------------------------//
/**
 * lʂҏW
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    EditableList list=new EditableList();
    SequenceFileListPanel panel=new SequenceFileListPanel(frame,list);
    int ans=JOptionPane.showOptionDialog
      	      (frame,panel,actionName(),
      	       JOptionPane.DEFAULT_OPTION,JOptionPane.PLAIN_MESSAGE,
      	       null,BUTTONS,BUTTONS[1]);
    if(ans==0){
      int count=list.getDefaultListModel().getSize();
      int format=panel.getFormat();
      try{
      	for(int i=0;i<count;i++){
      	  File file1=(File)list.getDefaultListModel().get(i);
      	  String path=file1.getAbsolutePath();
      	  File file2;
      	  if(format==SequenceFileListPanel.PNG){
      	    file2=new File(path.replaceAll("\\..*",".png"));
      	  }
      	  else{
      	    file2=new File(path.replaceAll("\\..*",".bmp"));
      	  }
      	  toImageFile(file1,file2,format);
      	  System.out.println(file1.getName()+" to "+file2.getName());
      	}
      	JOptionPane.showMessageDialog
      	  (frame,WordMap.get(WordMap.FINISH_SEQUENCE),
      	   CommandMap.get(CommandMap.FINISH),
      	   JOptionPane.INFORMATION_MESSAGE);
      }
      catch(Exception ex){
      	ex.printStackTrace();
      }
    }
  }

//--------------------------------------------------------------------//
/**
 * 摜t@C쐬
 * @param file1 f[^t@C
 * @apram file2 摜t@C
 * @throws Exception 炩̗RŃt@Co͂oȂƂ
 */
  protected void toImageFile(File file1,File file2,int format)
    throws Exception{

    ChannelFlowIO flowIO=new ChannelFlowIO(frame.getModel());
    flowIO.read(file1);
    frame.setTitle(file1.getName());
    frame.getPanel().resetCoordinates();
    frame.getPanel().update();
    if(format==SequenceFileListPanel.PNG){
      ImageIO.write(frame.getPanel().getImage(),"png",file2);
    }
    else{
      BitmapImageIO imageIO=
      	new BitmapImageIO(frame.getPanel().getImage());
      imageIO.write(file2);
    }
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return WordMap.get(WordMap.SEQUENCE);
  }
}
