package iso.component;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.text.DecimalFormat;
import javax.swing.AbstractAction;
import javax.swing.Icon;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.border.TitledBorder;
import figure.Transform;
import laf.CommandMap;
import laf.WordMap;

//--------------------------------------------------------------------//
/**
 * _ϊsݒANV
 */
public class SetTransformAction extends AbstractAction{

/** _CAO{^ */
  protected static final String
    BUTTONS[]={CommandMap.get(CommandMap.SET),
      	       CommandMap.get(CommandMap.CANCEL)};
/** l */
  protected static final DecimalFormat
    FORM=new DecimalFormat("#####0.0####");

/** \t[ */
  private ChannelFlowViewFrame frame;

/**
 * ANV\z
 * @param frame \t[
 */
  public SetTransformAction(ChannelFlowViewFrame frame){
    putValue(NAME,actionName());
    this.frame=frame;
  }

/**
 * ACRw肵ăANV\z
 * @param frame \t[
 * @param icon ACR
 */
  public SetTransformAction(ChannelFlowViewFrame frame,Icon icon){
    putValue(SMALL_ICON,icon);
    putValue(SHORT_DESCRIPTION,actionName());
    this.frame=frame;
  }

//--------------------------------------------------------------------//
/**
 * _ϊsݒ肷
 * @param e ANVƂCxg
 */
  public void actionPerformed(ActionEvent e){
    TransformPanel panel=new TransformPanel
      (frame.getViewModel().getTransform());
    int ans=JOptionPane.showOptionDialog
      	      (frame,panel,actionName(),
      	       JOptionPane.DEFAULT_OPTION,JOptionPane.PLAIN_MESSAGE,
      	       null,BUTTONS,BUTTONS[1]);
    if(ans==0){
      panel.set();
      frame.getPanel().update();
    }
  }

//--------------------------------------------------------------------//
/**
 * ANV̂Ԃ
 * @return ANV
 */
  public static String actionName(){
    return WordMap.get(WordMap.TRANSFORM);
  }

//--------------------------------------------------------------------//
/**
 * _ϊsݒpl
 */
  public class TransformPanel extends JPanel{

/** ϊs */
    protected Transform trans;

/** s񐬕̓tB[h */
    protected JTextField transField[][];

/**
 * _ϊsݒpl\z
 * @param trans ϊs
 */
    public TransformPanel(Transform trans){
      super();
      this.trans=trans;
      setLayout(new GridLayout(3,4));
      transField=new JTextField[3][4];
      for(int i=0;i<3;i++){
      	for(int j=0;j<4;j++){
      	  transField[i][j]=new JTextField
      	    (FORM.format(trans.trans[i][j]),10);
      	  transField[i][j].setBorder
      	    (new TitledBorder("R"+(i+1)+"C"+(j+1)));
      	  add(transField[i][j]);
      	}
      }
    }

//--------------------------------------------------------------------//
/**
 * _ϊsݒ肷
 */
    public void set(){
      try{
      	for(int i=0;i<3;i++){
      	  for(int j=0;j<4;j++){
      	    trans.trans[i][j]=
      	      Double.parseDouble(transField[i][j].getText());
      	  }
      	}
      }
      catch(NumberFormatException ex){
      	ex.printStackTrace();
      }
    }
  }
}
