package iso.io;
import java.awt.Component;
import java.io.File;
import javax.imageio.ImageIO;
import javax.swing.Icon;
import javax.swing.JFileChooser;
import javax.swing.filechooser.FileFilter;
import fileio.BitmapImageFileFilter;
import fileio.BitmapImageIO;
import fileio.FileSaveAction;
import fileio.WritableImageFileFilter;
import iso.component.ChannelFlowViewFrame;

//--------------------------------------------------------------------//
/**
 * t@CۑANV
 */
public class ChannelFlowSaveAction extends FileSaveAction{

/** \t[ */
  private ChannelFlowViewFrame frame;

/**
 * ANV\z
 * @param frame \t[
 */
  public ChannelFlowSaveAction(ChannelFlowViewFrame frame){
    super();
    this.frame=frame;
  }

/**
 * ACRw肵ăANV\z
 * @param frame \t[
 * @param icon ACR
 */
  public ChannelFlowSaveAction(ChannelFlowViewFrame frame,Icon icon){
    super(icon);
    this.frame=frame;
  }

//--------------------------------------------------------------------//
/**
 * [UI\ȃt@CtB^i[zԂ
 * @return [UI\ȃt@CtB^
 */
  protected FileFilter[] getFileFilters(){
    return new FileFilter[]{new WritableImageFileFilter(),
      	      	      	    new BitmapImageFileFilter()};
  }

//--------------------------------------------------------------------//
/**
 * t@CI_CAOԂ
 * @return t@CI_CAO
 */
  protected JFileChooser getFileChooser(){
    JFileChooser fileChooser=super.getFileChooser();
    fileChooser.setFileFilter(filters[0]);
    return fileChooser;
  }

//--------------------------------------------------------------------//
/**
 * _CAȌL҂Ԃ
 * @return _CAOL Component
 */
  protected Component getDialogOwner(){
    return frame;
  }

//--------------------------------------------------------------------//
/**
 * t@CC
 * @param file ̃t@C
 * @param filter t@CI_CAOőIꂽt@CtB^
 * @return Cꂽt@C
 */
  protected File modifiedFile(File file,FileFilter filter){
    String fileName=file.getAbsolutePath();
    String lowerName=file.getName().toLowerCase();
    if(filter==null){
      return file;
    }
    else if(filter.equals(filters[0])){
      if(!lowerName.endsWith(".png")){
      	return new File(fileName+".png");
      }
    }
    else if(filter.equals(filters[1])){
      if(!lowerName.endsWith(".bmp")){
      	return new File(fileName+".bmp");
      }
    }
    return file;
  }

//--------------------------------------------------------------------//
/**
 * t@CɃf[^ۑ
 * @param file ۑt@C
 * @throws Exception 炩̗RŃt@CȂƂ
 */
  protected void save(File file) throws Exception{
    if(file.getName().toLowerCase().endsWith(".bmp")){
      BitmapImageIO imageIO=
      	new BitmapImageIO(frame.getPanel().getImage());
      imageIO.write(file);
    }
    else{
      ImageIO.write(frame.getPanel().getImage(),"png",file);
    }
  }
}
