package laf;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;
import javax.swing.plaf.metal.MetalLookAndFeel;

//--------------------------------------------------------------------//
/**
 * `p[^
 */
public class DrawParameter{

/** UIL\ */
  public static final String ON="ON";

/** UI\ */
  public static final String OFF="OFF";

/** ^bNAhtB[NX */
  public static final String
    METAL_CLASS="javax.swing.plaf.metal.MetalLookAndFeel";

/** {\킷 */
  public static final String JAPANESE="Japanese";

/** p\ */
  public static final String ENGLISH="English";

/** `p[^i[}bv */
  private static DrawParameterMap map=new DrawParameterMap();

//--------------------------------------------------------------------//
/**
 * T|[gĂL[o
 * @return T|[gĂL[i[z
 */
  public static DrawParameterKey[] getSupportedKeys(){
    return map.getSupportedKeys();
  }

//--------------------------------------------------------------------//
/**
 * li[
 * @param key }bṽL[
 * @param value i[镶
 */
  public static void putString(DrawParameterKey key,String value){
    map.put(key,value);
  }

//--------------------------------------------------------------------//
/**
 * lo
 * @param key }bṽL[
 * @return oꂽl\
 */
  public static String getString(DrawParameterKey key){
    return map.getString(key);
  }

//--------------------------------------------------------------------//
/**
 * UI ݒ肷
 * @param decorated UIL̏ꍇ true
 */
  public static void setDecorated(boolean decorated){
    if(decorated){
      map.put(DrawParameterKey.DECORATED,ON);
    }
    else{
      map.put(DrawParameterKey.DECORATED,OFF);
    }
    setDecorated();
  }

//--------------------------------------------------------------------//
/**
 * UI ݒ肷
 */
  public static void setDecorated(){
    boolean decorated=getDecorated();
    JDialog.setDefaultLookAndFeelDecorated(decorated);
    JFrame.setDefaultLookAndFeelDecorated(decorated);
  }

//--------------------------------------------------------------------//
/**
 * UI L邩ǂԂ
 * @return UI L̏ꍇ true
 */
  public static boolean getDecorated(){
    String decorated=map.getString(DrawParameterKey.DECORATED);
    if(decorated==null) return false;
    return (decorated.equals(ON));
  }

//--------------------------------------------------------------------//
/**
 * ^e[}ݒ肷
 * @param theme Vݒ肷郁^e[}
 */
  public static void setMatalTheme(VariableMetalTheme theme){
    map.put(DrawParameterKey.THEME_NAME,theme.getName());
    for(int i=0;i<VariableMetalTheme.COLORS;i++){
      map.put(DrawParameterKey.THEME_COLORS[i],theme.getColor(i));
    }
    setMatalTheme();
  }

//--------------------------------------------------------------------//
/**
 * ^e[}ݒ肷
 */
  public static void setMatalTheme(){
    MetalLookAndFeel.setCurrentTheme(getMatalTheme());
  }

//--------------------------------------------------------------------//
/**
 * ^e[}Ԃ
 * @return ݂̃^e[}
 */
  public static VariableMetalTheme getMatalTheme(){
    VariableMetalTheme defaultTheme=new VariableMetalTheme();
    String name=map.getString(DrawParameterKey.THEME_NAME);
    if(name==null) name=defaultTheme.getName();
    Color color[]=new Color[VariableMetalTheme.COLORS];
    for(int i=0;i<VariableMetalTheme.COLORS;i++){
      color[i]=map.getColor(DrawParameterKey.THEME_COLORS[i]);
      if(color[i]==null) color[i]=defaultTheme.getColor(i);
    }
    return new VariableMetalTheme(name,color);
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[NXݒ肷
 * @param className bNAhtB[NX
 */
  public static void setLookAndFeel(String className){
    map.put(DrawParameterKey.LAF_CLASS,className);
    setLookAndFeel();
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[NXݒ肷
 */
  public static void setLookAndFeel(){
    try{
      String laf=getLookAndFeel();
      if(laf!=null) UIManager.setLookAndFeel(laf);
    }
    catch(ClassNotFoundException ex){
    }
    catch(InstantiationException ex){
    }
    catch(IllegalAccessException ex){
    }
    catch(UnsupportedLookAndFeelException ex){
    }
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[NXԂ
 * @return bNAhtB[NX
 */
  public static String getLookAndFeel(){
    return map.getString(DrawParameterKey.LAF_CLASS);
  }

//--------------------------------------------------------------------//
/**
 * bNAhtB[ݒ肷
 */
  public static void set(){
    setDecorated();
    setMatalTheme();
    setLookAndFeel();
  }

//--------------------------------------------------------------------//
/**
 * tHgݒ肷
 * @param font Vݒ肷tHg
 */
  public static void setFont(Font font){
    map.put(DrawParameterKey.FONT_NAME,font.getName());
    map.put(DrawParameterKey.FONT_STYLE,font.getStyle());
    map.put(DrawParameterKey.FONT_SIZE,font.getSize());
  }

//--------------------------------------------------------------------//
/**
 * tHgԂ
 * @return ݂̃tHg
 */
  public static Font getFont(){
    return map.getFont();
  }

//--------------------------------------------------------------------//
/**
 * wiFݒ肷
 * @param backgroundColor Vݒ肷wiF
 */
  public static void setBackgroundColor(Color backgroundColor){
    map.put(DrawParameterKey.BG_COLOR,backgroundColor);
  }

//--------------------------------------------------------------------//
/**
 * wiFԂ
 * @return ݂̔wiF
 */
  public static Color getBackgroundColor(){
    return map.getColor(DrawParameterKey.BG_COLOR);
  }

//--------------------------------------------------------------------//
/**
 * OiFݒ肷
 * @param foregroundColor Vݒ肷OiF
 */
  public static void setForegroundColor(Color foregroundColor){
    map.put(DrawParameterKey.FG_COLOR,foregroundColor);
  }

//--------------------------------------------------------------------//
/**
 * OiFԂ
 * @return ݂̑OiF
 */
  public static Color getForegroundColor(){
    return map.getColor(DrawParameterKey.FG_COLOR);
  }

//--------------------------------------------------------------------//
/**
 * ⏕\Fݒ肷
 * @param subColor Vݒ肷⏕\F
 */
  public static void setSubColor(Color subColor){
    map.put(DrawParameterKey.SUB_COLOR,subColor);
  }

//--------------------------------------------------------------------//
/**
 * ⏕\FԂ
 * @return ݂̕⏕\F
 */
  public static Color getSubColor(){
    return map.getColor(DrawParameterKey.SUB_COLOR);
  }

//--------------------------------------------------------------------//
/**
 * ݒ肷
 * @param language Vݒ肷錾ԍ
 */
  public static void setLanguage(String language){
    map.put(DrawParameterKey.LANGUAGE,language);
  }

//--------------------------------------------------------------------//
/**
 * Ԃ
 * @return ݂̌ԍ
 */
  public static String getLanguage(){
    return map.getString(DrawParameterKey.LANGUAGE);
  }
}
