package laf;
import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import javax.xml.parsers.ParserConfigurationException;
import org.xml.sax.SAXException;
import resourcemanager.WordManager;
import resourcemanager.XMLDataMap;

//--------------------------------------------------------------------//
/**
 * gpPǗNX
 */
public class WordMap extends XMLDataMap{

/** ^Cg\ */
  public static final String TITLE="title";

/** lʂ\ */
  public static final String ISOSURFACE="isosurface";

/** lʕҏW\ */
  public static final String EDIT="edit";

/** lʒǉ\ */
  public static final String ADD="add";

/** lʒǉ\ */
  public static final String REPLACE="replace";

/** lʍ폜\ */
  public static final String REMOVE="remove";

/** f[^ނ\ */
  public static final String TYPE="type";

/**  <i>x</i>  u \ */
  public static final String U="u";

/**  <i>y</i>  v \ */
  public static final String V="v";

/**  <i>z</i>  w \ */
  public static final String W="w";

/** ϓ p \ */
  public static final String P="p";

/**  uv (u>0) \ */
  public static final String UV1="uv1";

/**  uv (u<0) \ */
  public static final String UV2="uv2";

/** 臒l\ */
  public static final String THRESHOLD="threshold";

/** \F\ */
  public static final String COLOR="color";

/** _ϊs\ */
  public static final String TRANSFORM="transform";

/** V[PX\ */
  public static final String SEQUENCE="sequence";

/** t@CXg\ */
  public static final String FILE_LIST="filelist";

/** t@CK\\ */
  public static final String REG_EX="regex";

/** Xebvŏl\ */
  public static final String MIN_STEP="minstep";

/** Xebvől\ */
  public static final String MAX_STEP="maxstep";

/** fBNgI\ */
  public static final String PICK_DIRECTORY="pickdirectory";

/** 摜o͌`\ */
  public static final String IMAGE_FORMAT="imageformat";

/** V[PXs\ */
  public static final String DO_SEQUENCE="dosequence";

/** s\ */
  public static final String FINISH_SEQUENCE="finishsequence";

/** o[W\ */
  public static final String VERSION1="version1";

/** o[W\ */
  public static final String VERSION2="version2";

/** o[W\ */
  public static final String VERSION3="version3";

/** o[W\ */
  public static final String VERSION4="version4";

/** f[^i[}bv */
  private static WordMap current=new WordMap();

/**
 * gpPǗIuWFNg\z
 */
  public WordMap(){
    super();
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read()
    throws ParserConfigurationException,SAXException,IOException{
    read(WordManager.get());
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param language 
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(String language)
    throws ParserConfigurationException,SAXException,IOException{
    if(language.equals(DrawParameter.JAPANESE)){
      read(WordManager.get(WordManager.J_FILE_NAME));
    }
    else{
      read(WordManager.get());
    }
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param url f[^ URL
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(URL url)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromURL(url);
  }

//--------------------------------------------------------------------//
/**
 * gpPǂݍ
 * @param is ̓Xg[
 * @throws ParserConfigurationException
 *         vꂽ\𖞂 <code>DocumentBuilder</code>
 *         𐶐łȂƂ
 * @throws SAXException \̓G[Ƃ
 * @throws IOException o̓G[Ƃ
 */
  public static void read(InputStream is)
    throws ParserConfigurationException,SAXException,IOException{
    current.readFromStream(is);
  }

//--------------------------------------------------------------------//
/**
 * gpPԂ
 * @param key P̃L[
 * @return P
 */
  public static String get(String key){
    return current.getName(key);
  }
}
