package shading;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Point;
import figure.Point3D;
import figure.Triangle3D;
import figure.Vector3D;

//--------------------------------------------------------------------//
/**
 * tbgVF[fBONX
 */
public class FlatShading extends Shading{

/**  */
  public static final Vector3D VIEW_VECTOR=new Vector3D(0.0,0.0,-1.0);

/**
 * tbgVF[fBOIuWFNg\z
 * @param centerPoint ʒ_
 * @param width ʕ
 * @param height ʍ
 * @param lightPoint 
 */
  public FlatShading(Point centerPoint,int width,int height,
      	      	     Point3D lightPoint){
    super(centerPoint,width,height,lightPoint);
  }

/**
 * tbgVF[fBOIuWFNg\z
 * @param centerPoint ʒ_
 * @param size ʃTCY
 * @param lightPoint 
 */
  public FlatShading(Point centerPoint,Dimension size,
      	      	     Point3D lightPoint){
    this(centerPoint,size.width,size.height,lightPoint);
  }

//--------------------------------------------------------------------//
/**
 * Op`̃VF[fBO`vZ
 * @param tri Op`
 * @param color Op`̐F
 * @param pixel sNZf[^i[z
 * @param zbuf <i>z</i> W̃obt@i[z
 */
  public void shading(Triangle3D tri,Color color,int pixel[],
      	      	      double zbuf[]){
    Vector3D lightv=new Vector3D(lightPoint,tri.center());
    lightv.normalize();
    int rgb=LIGHT_MODEL.getColor(VIEW_VECTOR,lightv,tri.nv,color,1.5,
      	      	      	      	 false).getRGB();

    int x1=centerPoint.x+(int)Math.rint(tri.v1.x);
    int y1=centerPoint.y-(int)Math.rint(tri.v1.y);
    int x2=centerPoint.x+(int)Math.rint(tri.v2.x);
    int y2=centerPoint.y-(int)Math.rint(tri.v2.y);
    int x3=centerPoint.x+(int)Math.rint(tri.v3.x);
    int y3=centerPoint.y-(int)Math.rint(tri.v3.y);
    int delta=(x2-x1)*(y3-y1)-(y2-y1)*(x3-x1);
    if(delta==0) return;
    if(Math.abs(tri.nv.z)<1.0e-8) return;
    int xmax=Math.min(Math.max(Math.max(x1,x2),x3),width-1);
    int xmin=Math.max(Math.min(Math.min(x1,x2),x3),0);
    int ymax=Math.min(Math.max(Math.max(y1,y2),y3),height-1);
    int ymin=Math.max(Math.min(Math.min(y1,y2),y3),0);

    double z0=tri.v1.z;
    double zx=-tri.nv.x/tri.nv.z;
    double zy=tri.nv.y/tri.nv.z;
    for(int x=xmin;x<=xmax;x++){
      int dx=x-x1;
      for(int y=ymin;y<=ymax;y++){
      	int dy=y-y1;
      	int xsi=(y3-y1)*dx-(x3-x1)*dy;
      	int eta=-(y2-y1)*dx+(x2-x1)*dy;
      	int d2=delta-xsi-eta;
      	if(((xsi>=0) && (eta>=0) && (d2>=0))
      	|| ((xsi<=0) && (eta<=0) && (d2<=0))){
      	  double z=zx*dx+zy*dy+z0;
      	  int ii=width*y+x;
      	  if(zbuf[ii]<z){
      	    pixel[ii]=rgb;
      	    zbuf[ii]=z;
      	  }
      	}
      }
    }
  }
}
